import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This class is the Bus class
 * 
 * @Brian Huang && Mr. Cohen
 * @Feb 2012
 * 
 */
public class Bus extends Vehicle
{
    //The speed of the bus
    private int speed = 1;
    //Time before the Vehicle dies off
    private int timerBeforeDie;
    //Check if hit
    private boolean hit;
    /**
     * Bus Constructor
     *
     * @Every time this vehicle is declared
     * it ask whether it will be going the
     * right way or not.
     */
    public Bus (boolean goingTheRightWay) {
        if (goingTheRightWay == false) {
            this.setRotation (180);
        }
        timerBeforeDie = 0;
        hit = false;
    }

    /**
     * Method act
     *
     *Here it loops and the vehicle does its thing
     */
    public void act()
    {
        drive();
        checkHitPedestrian ();
        checkHitOtherVehicle ();
    }

    /**
     * Method drive
     *
     *This vehicle move in the direction according to
     *its speed and rotation
     */
    public void drive()
    {
        move (speed);
    }

    /**
     * Method checkHitPedestrian
     *
     *Here the vehicle checks it it touches
     *a Pedestrian
     */
    public void checkHitPedestrian ()
    {
        // Check collision for a pedestrian one pixel ahead
        // of the Vehicle
        Pedestrian p = (Pedestrian)getOneObjectAtOffset((this.getImage().getWidth() / 2) + 1, 0, Pedestrian.class);
        if (p != null)
        {
            p.pickMeUp();
        }
    }

    /**
     * check if it hits another vehicle
     * If it does, the vehicle explodes
     */
    public void checkHitOtherVehicle () {
        if (getOneIntersectingObject(Vehicle.class) != null&& hit == false) {
            this.setImage ("explosion.png");
            new GreenfootSound ("explode.wav").play ();
            hit = true;
        }
        if (hit == true) {
            //Delay before death
            if (timerBeforeDie==0) timerBeforeDie=1;
            else if (timerBeforeDie>3)getWorld().removeObject(this);
            else timerBeforeDie++;
        }
    }
}
