import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This class is the Car class
 * 
 * @Brian Huang && Mr. Cohen
 * @Feb 2012
 * 
 */
public class Car extends Vehicle
{

    private int speed = 3;
    private int offset;
    //Time before the Vehicle dies off
    private int timerBeforeDie;
    private Pedestrian p;
    private Actor a;
    //Check if hit
    private boolean hit;

    /**
     * Car Constructor
     *
     * @Every time this vehicle is declared
     * it ask whether it will be going the
     * right way or not.
     */
    public Car (boolean goingTheRightWay) {
        if (goingTheRightWay == false) {
            this.setRotation (180);
        }
        timerBeforeDie = 0;
        hit = false;
    }

    /**
     * Method act
     *
     *Here it loops and the vehicle does its thing
     */
    public void act()
    {
        drive();
        checkHitPedestrian();
        checkHitOtherVehicle ();
    }

    /**
     * Method that deals with movement
     */
    public void drive() 
    {
        move (speed);
    }    

    /**
     * check if I hit a Pedestrian, and if so, act
     * accordingly
     */
    public void checkHitPedestrian ()
    {
        // Check collision for a pedestrian one pixel ahead
        // of the Vehicle
        offset = 30;

        p = (Pedestrian)getOneObjectAtOffset(offset, 0, Pedestrian.class);
        if (p != null)
        {

            p.knockMeOver();
        }
    }

    /**
     * check if it hits another vehicle
     * If it does, the vehicle explodes
     */
    public void checkHitOtherVehicle () {
        if (getOneIntersectingObject(Vehicle.class) != null && hit == false) {
            this.setImage ("explosion.png");
            new GreenfootSound ("explode.wav").play ();
            hit = true;
        }
        if (hit == true) {
            //Delay before death
            if (timerBeforeDie==0) timerBeforeDie=1;
            else if (timerBeforeDie>3)getWorld().removeObject(this);
            else timerBeforeDie++;
        }
    }
}
